commit 28fc1297adde1be51f25a13e110d38dd9e804320
Author: Philipp Tomsich <philipp.tomsich@vrull.eu>
Date:   Mon Jan 30 23:40:26 2023 +0100

    PR target/108589 - Check REG_P for AARCH64_FUSE_ADDSUB_2REG_CONST1
    
    This adds a check for REG_P on SET_DEST for the new idiom recognizer
    for AARCH64_FUSE_ADDSUB_2REG_CONST1.  The reported ICE is only
    observable with checking=rtl.
    
    Bootstrapped/regtested aarch64-linux, committed.
    
            PR target/108589
    
    gcc/ChangeLog:
    
            * config/aarch64/aarch64.c (aarch_macro_fusion_pair_p): Check
            REG_P on SET_DEST.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/aarch64/pr108589.c: New test.
    
    (cherry picked from commit a39c6ec97906766ad65d15d4856fd41121ee7a45)

diff --git a/gcc/config/aarch64/aarch64.c b/gcc/config/aarch64/aarch64.c
index 7bc6e5153ad..e6bf5ae3808 100644
--- a/gcc/config/aarch64/aarch64.c
+++ b/gcc/config/aarch64/aarch64.c
@@ -22155,6 +22155,7 @@ aarch_macro_fusion_pair_p (rtx_insn *prev, rtx_insn *curr)
 	  && CONST_INT_P (XEXP (curr_src, 1))
 	  && INTVAL (XEXP (curr_src, 1)) == polarity
 	  && REG_P (XEXP (curr_src, 0))
+	  && REG_P (SET_DEST (prev_set))
 	  && REGNO (SET_DEST (prev_set)) == REGNO (XEXP (curr_src, 0)))
 	return true;
     }
diff --git a/gcc/testsuite/gcc.target/aarch64/pr108589.c b/gcc/testsuite/gcc.target/aarch64/pr108589.c
new file mode 100644
index 00000000000..861727f7268
--- /dev/null
+++ b/gcc/testsuite/gcc.target/aarch64/pr108589.c
@@ -0,0 +1,15 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target lp64 } */
+/* { dg-options "-Os -O2 -mtune=ampere1a -fno-split-wide-types" } */
+
+int i;
+__int128 j;
+short s;
+
+void
+foo (void)
+{
+  j -= i;
+  int l = i - __builtin_sub_overflow_p (0, 61680, s);
+  j -= __builtin_mul_overflow_p (i, l, 0);
+}

